mod descriptor_pool;
mod merging;
mod py_any_extras;

use descriptor_pool::create_cached_descriptor;
use merging::merge_msg_into_pyobj;
use prost_reflect::DynamicMessage;
use pyo3::{exceptions::PyRuntimeError, prelude::*};

#[pyfunction]
fn deserialize(obj: &PyAny, buf: &[u8]) -> PyResult<()> {
    let desc = create_cached_descriptor(obj)?;
    let msg = DynamicMessage::decode(desc, buf)
        .map_err(|_| PyRuntimeError::new_err("Error on deserializing."))?;
    merge_msg_into_pyobj(obj, &msg)?;
    Ok(())
}

#[pymodule]
fn betterproto_extras(_py: Python, m: &PyModule) -> PyResult<()> {
    m.add_function(wrap_pyfunction!(deserialize, m)?)?;
    Ok(())
}
